/***************
*
* g:\exe\txf\src\txldirs.c
*/
#include "txl.h"

#define SORT_DATE	1
#define SORT_SIZE	2
#define SORT_NAME	3
#define SORT_EXT	4
#define SORT_FAPX	5
#define PRI_NUM		30

int dirsortoption;
PRIORITY kindofpri[PRI_NUM] = {
/*   \                ިڸ/̧ٖ r D揇	*/
	{"Ŝ̃O",					"NIFTYLOG",      8,  1},
	{"eLXg[",				"NIFMAIL",       7,  2},
	{"oCi[",				"NIFBMAIL",      8,  3},
	{"NAPLPS[",				"NAPMAIL",       7,  4},
	{"z[p[eB[",			"HP",            3,  5},
	{"peBI",					"PATIO",         6,  6},
	{"eq`u(^^) --- e`owT|[g", "FRAV",    4,  7},
	{"snvmrtH[",		"FTOWNS",        6,  8},
	{"Rs",					"FREELOG",       7, 10},
	{"t[\tgEFA",			"FREESOFT",      8, 12},
	{"el",					"FMNEWS",        6, 15},
	{"tH[",					"F",             1,  9 + 0x100},
	{"NAPLPSVC\",				"WEATHER",       7, 11},
	{"ۋ",					"BILL",          4, 13},
	{"T̂m点",				"NEW",           3, 14},
	{"vtB[",			"PROFILE",       8, 16},
	{"tH[j[ꗗ",		"SIGN",          5, 17},
	{"qsmXg",				"RTN",           4, 18},
	{"CuXg",			"LIB",           4, 19},
	{"O񃍃OAEg",			"LASTLOG",       7, 20},
	{"[M",				"MAILSDL",       8, 21},
	{"Mσ[(obNAbv)",	"SENDMAIL",      8, 22},
	{"tH[ꗗ",			"MYFORUM.LOG",  12, 23},
	{"_E[hL^",			"DOWNLIST.DAT", 13, 24},
	{"Abv[hL^",			"UPLDLIST.DAT", 13, 25},
	{"_E[h][g",		"DOWNRATE.DAT", 13, 26},
	{"Abv[h][g",		"UPLDRATE.DAT", 13, 27},
	{"ʐML^",				"CONNECT.DAT",  12, 28},
	{"e`owǗfBNg",	"SYSTEM",        7, 29},
	{"",                            "",              0, 255},
};

int sort_date(struct find_t_s *x, struct find_t_s *y)
{
	int ret = 0;
	int sop = sortoption;
	if (x->attrib & y->attrib & _A_SUBDIR) {
		sop = dirsortoption;
	}
	else if ((x->attrib | y->attrib) & _A_SUBDIR) {
		if (x->attrib & _A_SUBDIR) {
			ret = -1;
		}
		else {
			ret = 1;
		}
		return (ret);
	}
	if (x->wr_date > y->wr_date) {
		ret = -1;
	}
	else if (x->wr_date < y->wr_date) {
		ret = 1;
	}
	else {
		if (x->wr_time > y->wr_time) {
			ret = -1;
		}
		else if (x->wr_time < y->wr_time) {
			ret = 1;
		}
	}
	if (sop < 0) {
		ret = -(ret);
	}
	return (ret);
}

int sort_size(struct find_t_s *x, struct find_t_s *y)
{
	int ret = 0;
	int sop = sortoption;
	if (x->attrib & y->attrib & _A_SUBDIR) {
		sop = dirsortoption;
	}
	else if ((x->attrib | y->attrib) & _A_SUBDIR) {
		if (x->attrib & _A_SUBDIR) {
			ret = -1;
		}
		else {
			ret = 1;
		}
		return (ret);
	}
	if (x->size > y->size) {
		ret = -1;
	}
	else if (x->size < y->size) {
		ret = 1;
	}
	if (sop < 0) {
		ret = -(ret);
	}
	return (ret);
}

int sort_name(struct find_t_s *x, struct find_t_s *y)
{
	int ret = 0;
	int sop = sortoption;
	if (x->attrib & y->attrib & _A_SUBDIR) {
		sop = dirsortoption;
	}
	else if ((x->attrib | y->attrib) & _A_SUBDIR) {
		if (x->attrib & _A_SUBDIR) {
			ret = -1;
		}
		else {
			ret = 1;
		}
		return (ret);
	}
	ret = strcmp(x->name, y->name);
	if (sop > 0) {
		ret = -(ret);
	}
	return (ret);
}

int sort_ext(struct find_t_s *x, struct find_t_s *y)
{
	int ret = 0;
	char *xperiod = strchr(x->name, '.');
	char *yperiod = strchr(y->name, '.');
	int sop = sortoption;
	if (x->attrib & y->attrib & _A_SUBDIR) {
		sop = dirsortoption;
	}
	else if ((x->attrib | y->attrib) & _A_SUBDIR) {
		if (x->attrib & _A_SUBDIR) {
			ret = -1;
		}
		else {
			ret = 1;
		}
		return (ret);
	}
	if ((xperiod == NULL) && (yperiod == NULL)) {
		ret = sort_name(x, y);
		if (sortoption < 0) {
			ret = -(ret);
		}
	}
	else if (xperiod == NULL) {
		ret = -1;
	}
	else if (yperiod == NULL) {
		ret = 1;
	}
	else {
		ret = -(strcmp(xperiod, yperiod));
	}
	if (sop < 0) {
		ret = -(ret);
	}
	return (ret);
}

PRIORITY *howpri(struct find_t_s *z)
{
	int i;
	for (i = 0; i < PRI_NUM; i++) {
		if (strncmp(z->name, kindofpri[i].name, kindofpri[i].cmp) == 0) {
			break;
		}
	}
	return (&(kindofpri[i]));
}

int sort_fapx(struct find_t_s *x, struct find_t_s *y)
{
	int ret = 0;
	PRIORITY *xpri, *ypri;
	int sop = sortoption;
	if (x->attrib & y->attrib & _A_SUBDIR) {
		sop = dirsortoption;
	}
	else if ((x->attrib | y->attrib) & _A_SUBDIR) {
		if (x->attrib & _A_SUBDIR) {
			ret = -1;
		}
		else {
			ret = 1;
		}
		return (ret);
	}

	xpri = howpri(x);
	ypri = howpri(y);
	if (((xpri->pri) & 0x0ff) > ((ypri->pri) & 0x0ff)) {
		ret = -1;
	}
	else if (((xpri->pri) & 0x0ff) < ((ypri->pri) & 0x0ff)) {
		ret = 1;
	}
	if (sop < 0) {
		ret = -(ret);
	}
	if (ret == 0) {
		ret = sort_name(x, y);
	}
	return (ret);
}

int (*qsort_func_tbl[6])(struct find_t_s *x, struct find_t_s *y) = {
	NULL,
	sort_date,
	sort_size,
	sort_name,
	sort_ext,
	sort_fapx,
};

